unit uAdmassess_Shift_Visit_Location;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Trpcb, Buttons, Rpcconf1, Miscfp;

type
  TfrmVisitLoc = class(TForm)
    lblLabel1: TLabel;
    edtEdit1: TEdit;
    lstListBox1: TListBox;    lstListBox2: TListBox;
    btnButton1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Rpccall(Proc, P0, P1, P2, P3, Fall: String);
    procedure Changeclin(S: String);
    procedure btnButton1Click(Sender: TObject);
    procedure edtEdit1Change(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmVisitLoc: TfrmVisitLoc;

implementation

uses uAdmassess_Shift_Main;

{$R *.DFM}


procedure TfrmVisitLoc.FormCreate(Sender: TObject);
begin
  //Form7.Color:=$00D5A67B;
  Changeclin('A');
end;


procedure TfrmVisitLoc.Rpccall(Proc,P0,P1,P2,P3,Fall:String);
begin
  With Form1.brkrRpcbroker1 do begin
    RemoteProcedure:=Proc;
    If P0<>'' then begin Param[0].Value:=P0;  Param[0].Ptype:=literal;  end;
    If P1<>'' then begin Param[1].Value:=P1;  Param[1].Ptype:=literal;  end;
    If P2<>'' then begin Param[2].Value:=P2;  Param[2].Ptype:=literal;  end;
    If P3<>'' then begin Param[3].Value:=P3;  Param[3].Ptype:=literal;  end;
    If Fall<>'' then begin Param[4].Value:=Fall;  Param[4].Ptype:=literal;  end;
  end;
  try Form1.brkrRpcbroker1.Call;
  except On Ebrokererror do ShowMessage('Communication problem with VISTA!');
  end;
end;


procedure TfrmVisitLoc.Changeclin(S:String);
var I:integer;
begin
  lstListBox1.Clear;  lstListBox2.Clear;
  Rpccall('ORWU CLINLOC',S,'1','','','');
  For I:=0 to Form1.brkrRpcbroker1.Results.Count-1 do begin
    lstListBox1.Items.Add(Piece(Form1.brkrRpcbroker1.Results[I],'^',1));
    lstListBox2.Items.Add(Piece(Form1.brkrRpcbroker1.Results[I],'^',2));
  end;
  lstListBox2.Selected[0]:=True;
end;


procedure TfrmVisitLoc.btnButton1Click(Sender: TObject);
var I,OK:Integer;
begin
  OK:=-1;
  For I:=0 to lstListBox2.Items.Count-1 do
    If lstListBox2.Selected[I] then OK:=I;
  If Ok=-1 then begin
    Mb('You must select a location!','E');
    exit;
  end;
  Form1.lblLabel3.Caption:=Inttostr(OK);
  Close;
end;


procedure TfrmVisitLoc.edtEdit1Change(Sender: TObject);
begin
  If Length(edtEdit1.Text)>2 then Changeclin(edtEdit1.text);
end;


procedure TfrmVisitLoc.FormPaint(Sender: TObject);
var Row, Ht: Word ;
begin
Ht := (ClientHeight + 255) div 256 ;
  for Row := 0 to 255 do
   with Canvas do begin
     Brush.Color := RGB(0, 0, Row+70) ;
     FillRect(Rect(0, Row * Ht, ClientWidth, (Row + 1) * Ht)) ;
   end;
end;


procedure TfrmVisitLoc.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var I,OK:Integer;
begin
  OK:=-1;
  For I:=0 to lstListBox2.Items.Count-1 do
    If lstListBox2.Selected[I] then OK:=I;
  If Ok=-1 then begin
    Mb('You must select a location!','E');
    Canclose:=False;
  end;
  If Canclose then begin
    Form1.lblLabel3.Caption:=Inttostr(OK);
    Close;
  end;
end;


end.
