unit uAdmassess_PCE;

  (* Reminder re-do 1/14/08 *)

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls, Miscfp, Rpcconf1, Trpcb, ComCtrls,
  Buttons;

type
  TfrmPCE = class(TForm)
    calMonthCalendar1: TMonthCalendar;
    lblLabel1: TLabel;    lblLabel2: TLabel;    lblLabel3: TLabel;
    lblLabel4: TLabel;    lblLabel5: TLabel;
    lblHoldLabel: TLabel;
    lblRemLabel: TLabel;
    cbxComboBox1: TComboBox;
    rgrpRadioGroup1: TRadioGroup;    rgrpRadioGroup2: TRadioGroup;
    btnCancelButton: TBitBtn;        btnResolveButton: TBitBtn;
    edtEdit1: TEdit;
    memMemo1: TMemo;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure Rpccall(Proc, P0, P1, P2, P3, P4: String);
    procedure btnResolveButtonClick(Sender: TObject);
    procedure lblLabel2MouseEnter(Sender: TObject);
    procedure lblLabel2MouseLeave(Sender: TObject);
    procedure lblLabel2Click(Sender: TObject);
    procedure lblLabel3Click(Sender: TObject);
    procedure rgrpRadioGroup1Click(Sender: TObject);
  private
    Had,Previously,Declined,NA:Boolean;
    procedure Datechg(Timeperiod: String);
    procedure Spce(var S2: String; N: Integer);
    { Private declarations }
  public
    { Public declarations }
    U:Char;
  end;

var
  frmPCE: TfrmPCE;

implementation

uses uAdmassess_Main, uAdmassess_Error_Screen;

{$R *.dfm}


procedure TfrmPCE.FormCreate(Sender: TObject);
var I:Integer;
begin
  U:='^';  calMonthCalendar1.Date:=Date; 
  Had:=False;  Previously:=False;  Declined:=False;  NA:=False;
  For I:=0 to rgrpRadioGroup1.Items.Count-1 do begin
    If Contain(rgrpRadioGroup1.Items[I],'had') then Had:=True;
    If Contain(rgrpRadioGroup1.Items[I],'previously') then Previously:=True;
    If Contain(rgrpRadioGroup1.Items[I],'declined') then Declined:=True;
    If Contain(rgrpRadioGroup1.Items[I],'not applicable') then NA:=True;
  end;
end;


procedure TfrmPCE.Rpccall(Proc,P0,P1,P2,P3,P4:String);
begin
  With Form1.brkrRpcbroker1 do begin
    RemoteProcedure:=Proc;
    If P0<>'' then begin Param[0].Value:=P0;  Param[0].Ptype:=literal;  end;
    If P1<>'' then begin Param[1].Value:=P1;  Param[1].Ptype:=literal;  end;
    If P2<>'' then begin Param[2].Value:=P2;  Param[2].Ptype:=literal;  end;
    If P3<>'' then begin Param[3].Value:=P3;  Param[3].Ptype:=literal;  end;
    If P4<>'' then begin Param[4].Value:=P4;  Param[4].Ptype:=literal;  end;
  end;
  try Form1.brkrRpcbroker1.Call;
  except On Ebrokererror do ShowMessage('Error with RPC '+Proc+'!');
  end;
end;


procedure TfrmPCE.rgrpRadioGroup1Click(Sender: TObject);
var Cal,Combo:Boolean;
begin
  If Not rgrpRadioGroup2.Visible then rgrpRadioGroup2.Itemindex:=-1;
  If Contain(rgrpRadioGroup1.Items[rgrpRadioGroup1.Itemindex],'decline') then rgrpRadioGroup2.Itemindex:=4;
  rgrpRadioGroup2.Visible:=(Contain(rgrpRadioGroup1.Items[rgrpRadioGroup1.Itemindex],'had')) or
    (Contain(rgrpRadioGroup1.Items[rgrpRadioGroup1.Itemindex],'declined'));
  Cal:=False;  Combo:=False;
  If Contain(rgrpRadiogroup1.Items[rgrpRadiogroup1.Itemindex],'previously') then begin
    If Piece(lblRemLabel.Caption,U,9)='1' then Cal:=True;
    If Piece(lblRemLabel.Caption,U,10)='1' then Combo:=True;
  end;
  calMonthCalendar1.Visible:=Cal;  lblLabel1.Visible:=Cal;       lblLabel2.Visible:=Cal;
  lblLabel3.Visible:=Cal;          cbxCombobox1.Visible:=Combo;  lblLabel4.Visible:=Combo;
end;


procedure TfrmPCE.lblLabel2MouseEnter(Sender: TObject);
begin
  (Sender as TLabel).Font.Color:=clred;
end;


procedure TfrmPCE.lblLabel2MouseLeave(Sender: TObject);
begin
  (Sender as TLabel).Font.Color:=clgreen
end;


procedure TfrmPCE.lblLabel2Click(Sender: TObject);
begin
  Datechg('6M');
end;


procedure TfrmPCE.lblLabel3Click(Sender: TObject);
begin
  Datechg('1Y');
end;


procedure TfrmPCE.Datechg(Timeperiod:String);
var S,Sd,Sy:String;  I:Integer;
begin
  S:=Datetostr(calMonthCalendar1.Date);
  Sd:=Piece(S,'/',1);  Sy:=Piece(S,'/',3);
  If Contain(Timeperiod,'M') then begin
    I:=Strtoint(Sd)-Strtoint(Copy(Timeperiod,1,1));  Sd:=Inttostr(I);
    If I<1 then begin
      I:=I+12;  Sd:=Inttostr(I);
      I:=Strtoint(Sy)-1;  Sy:=Inttostr(I);
    end;
  end;
  If Contain(Timeperiod,'Y') then begin
    I:=Strtoint(Sy)-Strtoint(Copy(Timeperiod,1,1));  Sy:=Inttostr(I);
  end;
  S:=Sd+'/'+Piece(S,'/',2)+'/'+Sy;
  calMonthCalendar1.Date:=Strtodate(S);
end;


procedure TfrmPCE.btnResolveButtonClick(Sender: TObject);
Var Fmdate,S,S2:String;  OK:Boolean;
begin
  S:='';  Fmdate:='';
  If calMonthcalendar1.Visible then begin
    Form1.Rpccall('ORWU DT',Datetostr(calMonthcalendar1.Date),'','','','');
    Fmdate:=Form1.brkrRpcbroker1.Results[0];
  end;
  If rgrpRadiogroup1.Itemindex<0 then S:=S+#10+#13+'   Received not specified';
  If (rgrpRadioGroup2.Visible) and (rgrpRadiogroup2.Itemindex<0) then S:=S+#10+#13+'   Level of Understanding not specified';
  If (cbxCombobox1.Visible) and (cbxCombobox1.Text='') then S:=S+#10+#13+'   Location where done previously not specified';
  If S<>'' then begin
    S:='Cannot resolve reminder:'+#10+#13+S;
    Mb(S,'E');
    exit;
  end;
  S:=rgrpRadiogroup1.Items[rgrpRadiogroup1.Itemindex];
  With Form1.brkrRpcbroker1 do begin
    RemoteProcedure:='ORWPCE SAVE';
    Param[0].Ptype:=list;
    Param[0].Mult['1']:='HDR^0^^'+Piece(lblHoldlabel.Caption,U,2)+';'+Piece(lblHoldlabel.Caption,U,5)+';A';
    Param[0].Mult['2']:='VST^DT^'+Piece(lblHoldlabel.Caption,U,5);
    Param[0].Mult['3']:='VST^PT^'+Piece(lblHoldlabel.Caption,U,1);
    Param[0].Mult['4']:='VST^HL^'+Piece(lblHoldlabel.Caption,U,2);
    Param[0].Mult['5']:='VST^VC^D';
    If Contain(S,'had') then Spce(S2,4)
    else If Contain(S,'previously') then Spce(S2,7)
    else If Contain(S,'declined') then Spce(S2,12)
    else If Contain(S,'not applicable') then Spce(S2,15);
    Param[0].Mult['6']:=S2+'^^^^^1';
    S2:='';
    If cbxCombobox1.Visible then begin
      S2:=' Done previously at '+cbxCombobox1.Text;
      If calMonthcalendar1.Visible then S2:=S2+' '+Datetostr(calMonthCalendar1.Date);
    end;
    If edtEdit1.Text<>'' then Param[0].Mult['7']:='cbxCom^1^'+edtEdit1.Text+S2
    else begin
      If S2='' then Param[0].Mult['7']:='cbxCom^1^@'
      else Param[0].Mult['7']:='cbxCom^1^'+S2;
    end;
    Param[1].Ptype:=literal;  Param[1].Value:='0';
    Param[2].Ptype:=literal;  Param[2].Value:=Piece(lblHoldlabel.Caption,U,2);
  end;
  OK:=True;
  try Form1.brkrRpcbroker1.Call;
  except
    Showmessage('Error saving reminder, please retry.');  OK:=False;
  end;
  If OK then begin
    Mb('Reminder resolved!','I');
    Form1.btnRemButton4.Visible:=False;  Close;
    With Form1.memRemMemo2.Lines do begin
      Add(Piece(lblRemlabel.Caption,U,1));
      Add('  '+rgrpRadiogroup1.Items[rgrpRadiogroup1.Itemindex]);
      If rgrpRadiogroup2.Visible then Add('  Level of Understanding: '+rgrpRadiogroup2.Items[rgrpRadiogroup2.Itemindex]);
      If calMonthCalendar1.Visible then Add('  Date: '+Datetostr(calMonthCalendar1.Date));
      If cbxCombobox1.Visible then Add('  Location: '+cbxCombobox1.Text);
      If edtEdit1.Text<>'' then Add('  Comment: '+edtEdit1.Text);
      Add(' ');
    end;
  end;
end;


procedure TfrmPCE.Spce(var S2:String;  N:Integer);
var S:String;
begin
  S:=Piece(lblRemlabel.Caption,U,N);
  If S<>'' then S2:='HF+^'+Piece(S,';',1)+U+U+Piece(S,';',2)+'^@'
  else begin
    S:=Piece(lblRemlabel.Caption,U,N+1);
    If S<>'' then begin
      S2:='PED+^'+Piece(S,';',1)+U+U+Piece(S,';',2)+U;
      If rgrpRadiogroup2.Visible then S2:=S2+Inttostr(rgrpRadiogroup2.Itemindex+1)
      else S2:=S2+'4';
    end;
  end;
end;


end.
