unit uAdmassess_Shift_Allergy;

  (* 4/10/08 *)

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, CheckLst, Miscfp, Trpcb;

type
  TfrmAllergy = class(TForm)
    lblHoldLabel: TLabel;
    edtEdit1: TEdit;
    lstAllergyMatch: TListBox;
    rgrpRadioGroup1: TRadioGroup;
    cbxComboBox1: TComboBox;
    lstSigns: TCheckListBox;
    memComments: TMemo;
    btnCloseButton: TBitBtn;
    btnButton1: TButton;   btnOKButton: TButton;
    lblLabel1: TLabel;     lblLabel2: TLabel;    lblLabel3: TLabel;    lblLabel4: TLabel;
    lblLabel5: TLabel;     lblLabel6: TLabel;    lblLabel7: TLabel;    lblLabel8: TLabel;
    pnlButtons: TPanel;    pnlEntry: TPanel;    pnlSearch: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure btnButton1Click(Sender: TObject);
    procedure btnCloseButtonClick(Sender: TObject);
    procedure btnOKButtonClick(Sender: TObject);
    procedure edtEdit1Change(Sender: TObject);
    procedure edtEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure lstAllergyMatchDblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    Alg,Symp:TStrings;
    U:Char;
    procedure Allfalse;
    function Anychecked(C: String): Boolean;
    function Findcomp(S: String): Integer;
    procedure Getallergies;
    procedure RightSideVis(B: Boolean);
    procedure SearchAlg;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmAllergy: TfrmAllergy;

implementation

uses uAdmassess_Shift_Main;

{$R *.dfm}


procedure TfrmAllergy.FormCreate(Sender: TObject);
var I:Integer;  S:String;  OK:Boolean;
begin
  Alg:=TStringlist.Create;  Symp:=TStringlist.Create;  U:='^';
  lstSigns.Clear;
  Form1.Rpccall('ORWDAL32 DEF','','','','','');
  OK:=False;             For I:=0 to (Form1.brkrRpcbroker1.Results.Count-1) do begin
    S:=Form1.brkrRpcbroker1.Results[I];
    If Contain(S,'~Top Ten') then OK:=True
    else If (Ok) and (S[1]<>'i') then OK:=False;
    If (OK) and (Not Contain(S,'~Top Ten')) then begin
      lstSigns.Items.Add(Piece(S,U,2));
      S:=Piece(S,U,1);
      If S[1]='i' then S:=Copy(S,2,999);
      Symp.Add(S);
    end;
  end;
  Form1.Rpccall('NUPA LIST','120.83','S NUPA=$O(^GMRD(120.83,I,"TERMSTATUS",999),-1) I NUPA S NUPA=$P($G(^GMRD(120.83,I,"TERMSTATUS",NUPA,0)),U,2) I NUPA','','','');
  For I:=0 to (Form1.brkrRpcbroker1.Results.Count-1) do begin
    S:=Form1.brkrRpcbroker1.Results[I];
    lstSigns.Items.Add(Piece(S,U,1));  Symp.Add(Piece(S,U,2));
  end;
end;


procedure TfrmAllergy.btnButton1Click(Sender: TObject);
begin
  SearchAlg;
end;


procedure TfrmAllergy.SearchAlg;
begin
  If Length(edtEdit1.Text)<3 then exit;
  lstAllergyMatch.Visible:=True;
  lblLabel5.Enabled:=lstAllergyMatch.Visible;
  RightSideVis(False);
  If lstAllergyMatch.Visible then Getallergies;
end;


procedure TfrmAllergy.Getallergies;
var I:Integer;  S:String;
begin
  Form1.Rpccall('ORWDAL32 ALLERGY MATCH',edtEdit1.Text,'','','','');
  lstAllergyMatch.Clear;  Alg.Clear;
  If Form1.brkrRpcbroker1.Results.Count=1 then lstAllergyMatch.Items.Add('Not found!')
  else For I:=0 to (Form1.brkrRpcbroker1.Results.Count-1) do begin
    S:=Form1.brkrRpcbroker1.Results[I];
    If Contain(S,'^TOP') then begin
      S:='From '+Piece(S,U,2);  lstAllergyMatch.Items.Add('');  Alg.Add('');
    end
    else S:='  '+Piece(S,U,2);
    Alg.Add(Form1.brkrRpcbroker1.Results[I]);  lstAllergyMatch.Items.Add(S);
  end;
end;


procedure TfrmAllergy.lstAllergyMatchDblClick(Sender: TObject);
var S:String;
begin
  S:=lstAllergyMatch.Items[lstAllergyMatch.Itemindex];
  If (S='') or (Contain(S,'From')) then begin
    Mb('Invalid Selection!','E');
    exit;
  end;
  Allfalse;  RightSideVis(True);
end;


procedure TfrmAllergy.edtEdit1Change(Sender: TObject);
begin
  lstAllergyMatch.Visible:=False;
  lblLabel5.Enabled:=lstAllergyMatch.Visible;
  RightSideVis(False);
end;


procedure TfrmAllergy.edtEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  If (Key=chr(13)) and (Length(edtEdit1.Text)>=3) then SearchAlg;
end;


procedure TfrmAllergy.btnCloseButtonClick(Sender: TObject);
begin
  lstAllergyMatch.Visible:=False;  edtEdit1.Clear;
  lblLabel5.Enabled:=lstAllergyMatch.Visible;
  RightSideVis(False);
  Close;
end;


procedure TfrmAllergy.RightSideVis(B:Boolean);
begin
  rgrpRadiogroup1.Enabled:=B;  lblLabel6.Enabled:=B;
  lblLabel7.Enabled:=B;       lblLabel8.Enabled:=B;
  cbxCombobox1.Enabled:=B;    lstSigns.Visible:=B;
  memComments.Visible:=B;        btnOKButton.Enabled:=B;
  rgrpRadiogroup1.Itemindex:=-1;  cbxCombobox1.Text:='Allergy';
  If Not lstSigns.Visible then Allfalse;
  If Not memComments.Visible then memComments.Clear;
end;


procedure TfrmAllergy.Allfalse;
var I:Integer;
begin
  For I:=0 to lstSigns.Items.Count-1 do
    lstSigns.Checked[I]:=False;
end;


procedure TfrmAllergy.btnOKButtonClick(Sender: TObject);
var I,Lc:Integer;  Now,S:String;  OK:Boolean;  Ch:Char;
begin
  Form1.Rpccall('ORWU DT','NOW','','','','');
  If Form1.brkrRpcbroker1.Results.Count>0 then Now:=Form1.brkrRpcbroker1.Results[0]
  else Now:='';
  If rgrpRadiogroup1.Itemindex=-1 then begin
    Mb('Observed/Historical not selected!','E');
    exit;
  end;
  If cbxCombobox1.Text='' then begin
    Mb('Nature of Reaction not selected!','E');
    exit;
  end;
  If Not AnyChecked('lstSigns') then begin
    Mb('No symptoms Checked!','E');
    exit;
  end;
  With Form1.brkrRpcbroker1 do begin
    RemoteProcedure:='ORWDAL32 SAVE ALLERGY';
    Param[0].Value:='0';               Param[0].Ptype:=literal;
    Param[1].Value:=Piece(lblHoldlabel.Caption,U,1);  Param[1].Ptype:=literal;
    Param[2].Ptype:=list;
    S:=Alg[lstAllergyMatch.Itemindex];
    Param[2].Mult['"GMRAGNT"']:=Piece(Piece(S,U,2),' <',1)+U+Piece(S,U,1)+';'+Piece(Piece(S,U,3),'"',1);
    Param[2].Mult['"GMRATYPE"']:=Piece(S,U,4)+U;
    Param[2].Mult['"GMRANATR"']:=Copy(cbxCombobox1.Text,1,1)+U+cbxCombobox1.Text;
    Param[2].Mult['"GMRAORIG"']:=Piece(lblHoldLabel.Caption,U,2);
    Param[2].Mult['"GMRAORDT"']:=Now;
    Param[2].Mult['"GMRACHT"']:='1';
    Param[2].Mult['"GMRACHT",1']:=Now;
    S:=rgrpRadiogroup1.Items[rgrpRadiogroup1.Itemindex];
    Ch:=S[1];  Ch:=Chr(Ord(Ch)+32);
    Param[2].Mult['"GMRAOBHX"']:=Ch+U+Allupcase(S);
    Lc:=0;
    For I:=0 to lstSigns.Items.Count-1 do
      If lstSigns.Checked[I] then begin
        Inc(Lc);
        Param[2].Mult['"GMRASYMP",'+Inttostr(Lc)]:=Symp[I]+U+lstSigns.Items[I];
      end;
    Param[2].Mult['"GMRASYMP",0']:=Inttostr(Lc);
    Lc:=0;
    For I:=0 to memComments.Lines.Count-1 do begin
      Inc(Lc);
      Param[2].Mult['"GMRACMTS",'+Inttostr(Lc)]:=memComments.Lines[I];
    end;
    Param[2].Mult['"GMRACMTS",0']:=Inttostr(Lc);
  end;
  OK:=True;
  try Form1.brkrRpcbroker1.Call;
  except
    Mb('Error saving allergy, please retry.','E');  OK:=False;
  end;
  If OK then
    If Piece(Form1.brkrRpcbroker1.Results[0],U,1)='0' then Mb('Allergy save done!','I')
    else Mb(Piece(Form1.brkrRpcbroker1.Results[0],U,2),'E');
end;


function TfrmAllergy.AnyChecked(C:String):Boolean;
var I:Integer;  Comp:TComponent;  OK:Boolean;
begin
  OK:=False;
  Comp:=Components[Findcomp(C)];
  For I:=0 to (Comp as TCheckListBox).Items.Count-1 do
    If (Comp as TCheckListBox).Checked[I] then OK:=True;
  Result:=OK;
end;


function TfrmAllergy.Findcomp(S:String):Integer;
var I,II:Integer;  Comp:TComponent;
begin
  I:=999;  II:=0;
  Repeat
    Comp:=Components[II];
    If Comp.Name=S then begin
      I:=II;  II:=Componentcount;
    end;
    Inc(II);
  Until II>=Componentcount;
  Result:=I;
end;


procedure TfrmAllergy.FormDestroy(Sender: TObject);
begin
  Alg.Free;  Symp.Free;
end;


end.
