unit uAdmassess_Careplan_Newprob;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, CheckLst, Miscfp, VA508AccessibilityManager;

type
  TfrmNewProb = class(TForm)
    lblLabel1: TLabel;    lblLabel3: TLabel;    lblLabel4: TLabel;
    lblLabel5: TLabel;    lblLabel8: TLabel;
    lblDaLabel: TLabel;
    memMemo1: TMemo;
    lstCheckListBox1: TCheckListBox;
    lstListBoxArea: TListBox;
    lstSort: TListBox;         lstListBoxProbHold: TListBox;
    lstListBox1: TListBox;     lstListBoxHold: TListBox;
    btnCancelButton: TButton;  btnAddButton: TButton;    btnExitButton: TBitBtn;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure FormCreate(Sender: TObject);
    procedure lstListBoxAreaClick(Sender: TObject);
    procedure lstListBox1Click(Sender: TObject);
    procedure lstCheckListBox1Click(Sender: TObject);
    procedure btnAddButtonClick(Sender: TObject);
    procedure btnCancelButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lstCheckListBox1KeyPress(Sender: TObject; var Key: Char);
  private
    Problems:TStrings;
    function Anychecked(Clb: TCheckListBox): Boolean;
    procedure Lbcl(B: Boolean);
    procedure Showplans(Ty: String; var L1, L2, L3: TLabel; var M: TMemo;
      Lb: TListBox; var Clb: TCheckListBox);
    procedure OtherInts(Clb: TCheckListBox; S: String);
    procedure LMand(L: TLabel; B: Boolean);
    { Private declarations }
  public
    { Public declarations }
    U:Char;  Interventions:TStrings;
    procedure Lb1c;
    procedure Lbac;
  end;

var
  frmNewProb: TfrmNewProb;

implementation

uses uAdmassess_Careplan_Main;

{$R *.dfm}


procedure TfrmNewProb.FormCreate(Sender: TObject);
begin
  U:='^';  Interventions:=Tstringlist.Create;  Problems:=TStringlist.Create;
end;


procedure TfrmNewProb.lstListBoxAreaClick(Sender: TObject);
begin
  Lbac;
end;


procedure TfrmNewProb.Lbac;
var I:Integer;  S:String;
begin
  Lbcl(False);  Problems.Clear;
  Form1.Rpccall('NUPA LIST','1927.2','I $P(^(0),U,3)='+Piece(lstListboxHold.Items[lstListboxArea.Itemindex],U,2),'','','');
  If Form1.brkrRpcbroker1.Results.Count>0 then Lbcl(True);
  For I:=0 to Form1.brkrRpcbroker1.Results.Count-1 do begin
    S:=Piece(Form1.brkrRpcbroker1.Results[I],U,1);
    If S='ZOther 1' then S:='Other 1';
    If S='ZOther 2' then S:='Other 2';
    lstListbox1.Items.Add(S);
    Problems.Add(Piece(Form1.brkrRpcbroker1.Results[I],U,2));
  end;
end;


procedure TfrmNewProb.lstListBox1Click(Sender: TObject);
begin
  Lb1c;
end;


procedure TfrmNewProb.Lb1c;
begin
  If lstListBox1.Items[lstListBox1.Itemindex]='NOTHING FOUND' then begin
    Mb('Invalid selection!','E');  exit;
  end;
  Showplans(Piece(lstListboxHold.Items[lstListboxArea.Itemindex],U,1),lblLabel4,lblLabel5,lblLabel8,memMemo1,lstListBox1,lstCheckListBox1);
  Form1.Set508(lstCheckListBox1);
end;


procedure TfrmNewProb.Showplans(Ty:String; var L1,L2,L3:TLabel; var M:TMemo; Lb:TListBox; var Clb:TCheckListBox);
var I,II:Integer;  S:String;  B:Boolean;
begin
  L3.Caption:='0 plans selected.';
  With Clb do begin  Clear;  Visible:=True;  end;
  S:='';
  LstSort.Clear;  LstListboxProbHold.Clear;  Interventions.Clear;
  Form1.Rpccall('NUPA LIST2','^NUPA(1927.24,','1927.24^2','I $P(^(0),U,2)='+Problems[lstListbox1.Itemindex],'','');
  For I:=0 to Form1.brkrRpcbroker1.Results.Count-1 do begin
    II:=Form1.StoI(Piece(Form1.brkrRpcbroker1.Results[I],U,3),'Showplans1')+100;
    lstSort.Items.Add(Form1.ItoS(II,'Showplans2')+U+Piece(Form1.brkrRpcbroker1.Results[I],U,1)+U+Piece(Form1.brkrRpcbroker1.Results[I],U,2));
  end;
  For I:=0 to Form1.brkrRpcbroker1.Results.Count-1 do begin
    Clb.Items.Add(Piece(lstSort.Items[I],U,2));
    lstListboxProbHold.Items.Add(Piece(lstSort.Items[I],U,3));
    Interventions.Add(Piece(lstSort.Items[I],U,3));
  end;
  Form1.Rpccall('NUPA WP GET','^NUPA(1927.2,',Problems[lstListbox1.Itemindex]+',','2','','');    
  M.Visible:=False;  M.Clear;  L1.Enabled:=False;  LMand(L1,False);
  //If Debug then Showmessage('Showplans 5');
  If Form1.brkrRpcbroker1.Results.Count>0 then begin
    M.Readonly:=False;
    For I:=0 to Form1.brkrRpcbroker1.Results.Count-1 do
      M.Lines.Add(Piece(Form1.brkrRpcbroker1.Results[I],U,1));
    M.Visible:=True;  L1.Enabled:=True;
  end;
  L2.Enabled:=True;
  B:=Contain(Lb.Items[Lb.Itemindex],'Other');
  If B then M.Clear
  else M.Readonly:=True;
  Lmand(L1,B);
  S:='';
  btnAddButton.Visible:=True;  btnCancelButton.Visible:=True;  L2.Enabled:=True;
  If B then begin
    S:=InputBox('Other problems','Enter the other problem name:','');
    If S<>'' then begin
      Lb.Items[Lb.Itemindex]:=Piece(Lb.Items[Lb.Itemindex],': ',1)+': '+S;
      Mb('Be sure to enter the desired outcome (free text).','I');
    end;
    If S='' then begin
      L1.Enabled:=False;  L2.Enabled:=False;  Clb.Visible:=False;  M.Visible:=False;
      btnAddButton.Visible:=False;  btnCancelButton.Visible:=False;
    end;
  end;
end;


procedure TfrmNewProb.LMand(L:TLabel;  B:Boolean);
begin
  If (Not B) and (Contain(L.Caption,'*')) then L.Caption:=Piece(L.Caption,'* ',2);
  If (B) and (Not Contain(L.Caption,'*')) then L.Caption:='* '+L.Caption;
end;


procedure TfrmNewProb.btnAddButtonClick(Sender: TObject);
var Da,Duz,S,S2:String;  I,II:Integer;
begin
  If (Contain(lblLabel4.Caption,'*')) and (memMemo1.Lines.Count=0) then begin
    Mb('Please enter a desired outcome!','E');  exit;
  end;
  Da:=Piece(lblDaLabel.Caption,U,1);  Duz:=Piece(lblDaLabel.Caption,U,2);
  If Not Anychecked(lstCheckListBox1) then begin
    Mb('No interventions selected!','E');
    exit;
  end;
//  With Form1 do begin
    For I:=0 to lstCheckListBox1.Count-1 do  //file interventions
      If lstCheckListBox1.Checked[I] then begin
        Form1.Rpccall('NUPA NEW IF NONE','^NUPA(1927.4,'+Da+',20,',Interventions[I],'','','');
        S:=Form1.brkrRpcbroker1.Results[0];
        Form1.Rpccall('NUPA FILE','^NUPA(1927.4,'+Da+',20,',S+U+Da,'1','NOW','3');
        Form1.Rpccall('NUPA FILE','^NUPA(1927.4,'+Da+',20,',S+U+Da,'2',Duz,'4');
        S2:=Piece(lstCheckListBox1.Items[I],': ',2);
        If Contain(S2,' (') then S2:=Piece(S2,' (',1);
        Form1.Rpccall('NUPA FILE','^NUPA(1927.4,'+Da+',20,',S+U+Da,'3',S2,'3');
      end;
    If lstListbox1.Enabled then begin  //file problems
      Form1.Rpccall('NUPA NEW IF NONE','^NUPA(1927.4,'+Da+',21,',Problems[lstListbox1.Itemindex],'','','');
      S:=Form1.brkrRpcbroker1.Results[0];
      Form1.Rpccall('NUPA FILE','^NUPA(1927.4,'+Da+',21,',S+U+Da,'1','NOW','3');
      Form1.Rpccall('NUPA FILE','^NUPA(1927.4,'+Da+',21,',S+U+Da,'2',Duz,'4');
      If Contain(lblLabel4.Caption,'*') then begin
        Form1.Rpccall('NUPA FILE','^NUPA(1927.4,'+Da+',21,',S+U+Da,'3',Piece(lstListbox1.Items[lstListbox1.Itemindex],': ',2),'3');
        For II:=0 to memMemo1.Lines.Count-1 do
          Form1.Rpccall('NUPA WP SET','^NUPA(1927.4,'+Da+',21,'+S+',1',InttoStr(II+1),memMemo1.Lines[II],'','');
      end;
    end;
  //end;
  If lstListbox1.Enabled then S:='New Problem/Intervention'
  else S:='New Intervention';
  Mb(S+' added!','I');
  Lbcl(False);
end;


procedure TfrmNewProb.btnCancelButtonClick(Sender: TObject);
begin
  Lbcl(False);
end;


procedure TfrmNewProb.Lbcl(B:Boolean);
begin
  lstListbox1.Clear;  lstListbox1.Visible:=B;  lblLabel3.Enabled:=B;  Problems.Clear;
  If Not B then begin
    lblLabel4.Enabled:=False;  lblLabel5.Enabled:=False;     lstCheckListBox1.Visible:=False;
    memMemo1.Visible:=False;   btnAddButton.Visible:=False;  btnCancelButton.Visible:=False;
  end;
end;


function TfrmNewProb.Anychecked(Clb:TCheckListBox):Boolean;
var I:Integer;  OK:Boolean;
begin
  OK:=False;
  For I:=0 to Clb.Items.Count-1 do
    If Clb.Checked[I] then OK:=True;
  Result:=OK;
end;


procedure TfrmNewProb.FormDestroy(Sender: TObject);
begin
  Interventions.Free;  Problems.Free;
end;


procedure TfrmNewProb.lstCheckListBox1Click(Sender: TObject);
begin
  Otherints(lstCheckListBox1,lstListboxArea.Items[lstListboxArea.Itemindex]);
  Form1.Set508(lstCheckListBox1);
end;


procedure TfrmNewProb.lstCheckListBox1KeyPress(Sender: TObject; var Key: Char);
begin
  Otherints(lstCheckListBox1,lstListboxArea.Items[lstListboxArea.Itemindex]);
  Form1.Set508(lstCheckListBox1);
end;


procedure TfrmNewProb.OtherInts(Clb:TCheckListBox;  S:String);
var S2:String;
begin
  If Clb.Itemindex=-1 then exit;
  S2:='';
  If Not Contain(Clb.Items[Clb.Itemindex],'Other') then exit;
  If Not Clb.Checked[Clb.Itemindex] then Clb.Items[Clb.Itemindex]:=Piece(Clb.Items[Clb.Itemindex],':',1)
  else begin
    If Piececount(Clb.Items[Clb.Itemindex],' ')>2 then begin
      S2:=Piece(Clb.Items[Clb.Itemindex],' ',1)+' '+Piece(Clb.Items[Clb.Itemindex],' ',2);
      If Piececount(Clb.Items[Clb.Itemindex],' ')>3 then S2:=S2+' '+Piece(Clb.Items[Clb.Itemindex],' ',3);
    end
    else S2:='Other '+S;
    S2:=InputBox(S2+' Interventions','Enter the '+S2+' Intervention:','');
    S2:=Copy(S2,1,30);
    If S2='' then Clb.Checked[Clb.Itemindex]:=False
    else begin
      If Form1.Add508 then Clb.Items[Clb.Itemindex]:=Piece(Clb.Items[Clb.Itemindex],' (',1);
      Clb.Items[Clb.Itemindex]:=Clb.Items[Clb.Itemindex]+': '+S2;
    end;
  end;
end;


end.
