unit uAdmassess_Error_Screen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, CheckLst, Miscfp, ExtCtrls;

const crmycursor=1;

type
  TfrmError = class(TForm)
    lstListBox1: TListBox;    lstSendnotebox: TListBox;
    lblLabel1: TLabel;        lblLabel2: TLabel;
    btnBitBtn1: TBitBtn;      btnSavePlansButton: TBitBtn;
    lstCheckListBox1: TCheckListBox;
    Bevel1: TBevel;
    procedure btnBitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lstListBox1DblClick(Sender: TObject);
    procedure lstListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmError: TfrmError;

implementation

uses uAdmassess_Main;

{$R *.DFM}


procedure TfrmError.FormShow(Sender: TObject);
begin
  //Screen.Cursor:=crmycursor;
end;


procedure TfrmError.btnBitBtn1Click(Sender: TObject);
begin
  Close;
end;


procedure TfrmError.FormPaint(Sender: TObject);
var Row, Ht: Word ;
begin
Ht := (ClientHeight + 255) div 256 ;
  for Row := 0 to 255 do
   with Canvas do begin
     //Brush.Color := RGB(0, 0, Row) ;
     Brush.Color := RGB(140, 0, 0) ;
     FillRect(Rect(0, Row * Ht, ClientWidth, (Row + 1) * Ht)) ;
   end;
end;


procedure TfrmError.lstListBox1DblClick(Sender: TObject);
var S:String;  I:Integer;
begin
  If lstListBox1.Itemindex>-1 then begin
    S:=lstListBox1.Items[lstListBox1.Itemindex];
    For I:=0 to Form1.Tabdesc.Count-1 do
      If Piece(Form1.Tabdesc[I],'^',1)=Piece(S,' -',1) then Form1.lblTabswitchLabel.Caption:=Piece(Form1.Tabdesc[I],'^',2);
    Close;
  end;
end;


procedure TfrmError.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  lblLabel1.Caption:='  Cannot Upload Note.  The following errors were found:  ';  {for vitals & consult}
  Screen.Cursor:=crdefault;
end;


procedure TfrmError.lstListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  If (X<5) or (X>(lstListBox1.Width-25)) or (Y<5) or (Y>(lstListbox1.Height-15)) then Screen.Cursor:=crdefault
  else Screen.Cursor:=crmycursor;
end;

end.
